// inlets and outlets
inlets = 1;
outlets = 0;

function log() {
  for(var i=0,len=arguments.length; i<len; i++) {
    var message = arguments[i];
    if(message && message.toString) {
      var s = message.toString();
      if(s.indexOf("[object ") >= 0) {
        s = JSON.stringify(message);
      }
      post(s);
    }
    else if(message === null) {
      post("<null>");
    }
    else {
      post(message);
    }
  }
  post("\n");
}
 
log("___________________________________________________");
log("Reload:", new Date);

function bang() {	
	log("bang")
    var liveSet = new LiveAPI("live_set");
    if (!liveSet) {
        log("no live api object");
        return;
    }
	
    for (i = 0; i < liveSet.getcount("tracks"); i++) {
        api_string = "live_set tracks " + i;
        var liveTrack = LiveAPI(api_string);
        var trackName = liveTrack.get("name")
        log("Track ", i, " old name", trackName, "\n");
        var newName = ""
		for (j = 0; j < liveTrack.getcount("clip_slots"); j++) {
			path = "live_set tracks " + i + " clip_slots " + j + " clip"
			var clip = new LiveAPI(path)
			if (clip.id > 0) {
				newName = clip.get("name")
			}
		}
		if (newName) {
			log("New name from clip: ", newName)
        	liveTrack.set("name", newName)
		}
        
    }
}